GDB (xrefs)

Public Types | Public Member Functions | Public Attributes | List of all members
assign_4::value_type Struct Reference
Inheritance diagram for assign_4::value_type:

## Public Types
enum | state_type { zero, moved_from, throwing_construction, throwing_copy, throwing_copy_assignment, throwing_move, throwing_move_assignment, threw }

## Public Member Functions
| value_type ()=default
| value_type (state_type state_)
| value_type (value_type const &other)
value_type & | operator= (value_type const &other)
| value_type (value_type &&other)
value_type & | operator= (value_type &&other)
void | throw_if (state_type match)

## Public Attributes
state_type | state = zero

## Additional Inherited Members
Private Member Functions inherited from assign_4::mixin_counter
| mixin_counter ()
| mixin_counter (mixin_counter const &)
| ~mixin_counter ()

## Detailed Description

Definition at line 31 of file 4.cc.

## Member Enumeration Documentation

## ◆ state_type

enum assign_4::value_type::state_type

Enumerator
zero |
moved_from |
throwing_construction |
throwing_copy |
throwing_copy_assignment |
throwing_move |
throwing_move_assignment |
threw |

Definition at line 33 of file 4.cc.

## Constructor & Destructor Documentation

## ◆ value_type() [1/4]

assign_4::value_type::value_type | ( |  | ) |
| default

## ◆ value_type() [2/4]

assign_4::value_type::value_type | ( | state_type | state_ | ) |
| inline explicit

Definition at line 47 of file 4.cc.

References throw_if(), and throwing_construction.

## ◆ value_type() [3/4]

assign_4::value_type::value_type | ( | value_type const & | other | ) |
| inline

Definition at line 53 of file 4.cc.

References throw_if(), and throwing_copy.

## ◆ value_type() [4/4]

assign_4::value_type::value_type | ( | value_type && | other | ) |
| inline

Definition at line 67 of file 4.cc.

References moved_from, throw_if(), and throwing_move.

## Member Function Documentation

## ◆ operator=() [1/2]

value_type& assign_4::value_type::operator= | ( | value_type const & | other | ) |
| inline

Definition at line 60 of file 4.cc.

References state, throw_if(), and throwing_copy_assignment.

## ◆ operator=() [2/2]

value_type& assign_4::value_type::operator= | ( | value_type && | other | ) |
| inline

Definition at line 75 of file 4.cc.

References moved_from, state, throw_if(), and throwing_move_assignment.

## ◆ throw_if()

void assign_4::value_type::throw_if | ( | state_type | match | ) |
| inline

Definition at line 83 of file 4.cc.

References state, and threw.

Referenced by operator=(), and value_type().

## Member Data Documentation

## ◆ state

state_type assign_4::value_type::state = zero

Definition at line 92 of file 4.cc.

Referenced by operator=(), and throw_if().

The documentation for this struct was generated from the following file:

- /tmp/gdb-8.1/gdb/unittests/optional/assignment/4.cc